# Built With Holochain

Please click "suggest an edit", and add something you built with Holochain to the list!

- [Holochain Basic Chat](https://github.com/holochain/holochain-basic-chat)
- [Todo list UI (Gatsby/Redux)](https://github.com/kristoferlund/holochain-todo-redux)
- [TODOlist example](https://github.com/holochain/tasktaskic)
- [HoloChat Simple UI](https://github.com/holochain/holochat-rust)
- [HoloVault](https://github.com/holochain/holochain-ui/tree/develop/dna-src/holo-vault)
- [Simple App](https://github.com/holochain/simple-app)
- [Todo List tutorial](https://github.com/willemolding/holochain-rust-todo)
- [Hylo](https://www.hylo.com/): a social network for community management, messaging and collaboration. They have a working network, although apparently with no activity. See also https://github.com/Hylozoic/hylo-holo-dnas.
- [Coolcats2](https://github.com/pythagorean/coolcats2): happ intended to replace Twitter.
- [Learn Using Test Driven Development](https://github.com/holochain/dev-camp-tests-rust)
- [Holo](https://holo.host/). (People often confuse Holo and Holochain. To make it clear they are not the same thing, Holo is actually a web hosting happ, built on Holochain, to make it easier to bridge users to Holochain via web apps without having to know anything about Holochain, or do anything with it. It is not the same thing as Holochain, the agent-centric distributed app framework with unlimited scalability, or with scalability at least proportional to the number of nodes, with the limit on that number only being constrained by physics, number of computers,).
- [Producer’s Market](https://www.producersmarket.com/). Provides a market or exchange for producers and consumers, with at least the initial focus on agriculture. See also [this blog post](https://holochaincitizen.com/2018/09/15/why-did-this-agricultural-supply-chain-start-up-choose-holochain-over-stellar-ethereum-and-hashgraph/).
- [Morpheus Network](https://morpheus.network/): automated, global, platform-agnostic supply-chain network.
- [Holosupply](http://www.holosupply.io/): digital supply chain integration platform.
- [Hypergroove](https://www.hypergroove.co.uk/): a data-driven, SaaS platform for more sustainable, inclusive, community-driven agri-food systems, with a focus on urban agriculture and p2p trade.
- [Redgrid](https://redgrid.io/): a SaaS platform for the Internet of Energy, connecting energy generation and storage devices and owners with power-consuming appliances and users. The first app built will be "Market Adaptive Demand Management, which will allow users’ high consumption devices—such as HVACs—to automatically respond to external market prices and signals in order to reduce consumption and costs. This will be applied to households, commercial buildings and multi-building sites. The application will be integrated into utility demand management programs to pay users for reducing their demand peaks, easing strain on the grid." It also aims to provide access to the 1.2b people in energy poverty. See also https://holo.host/project/redgrid/.
- [Metavents](https://www.metavents.com/): a planning platform for events and humanitarian project with event fees donated to the same humanitarian projects, using the transparency of Holochain. It uses visual planning with 2D, 3D, VR/AR and AI.
- [Bridgit](https://beta.bridgit.io/) / [Crowdfact](http://crowdfact.io/). Bridgit is a Distributed Search and Discovery protocol and a protocol for the OverWeb, a new layer of trust, ideas, interactions, and experiences that display on top of the page source. Available as a Chrome extension. Crowdfact is part of Bridgit and involves crowd-sourced fact-checking.
- [Scribe](https://github.com/iPlumb3r/Th3Sr1b3Pr0j3ct): The SCRIBE Project aims to build a distributed Conceptionary Manager which is a distributed application that allows to manage one or more Conceptionaries. There's a Github repo at https://github.com/iPlumb3r/Th3Sr1b3Pr0j3ct.
- [Prtcl (The Underscore Protocol)](http://www.uprtcl.io/): a way for people to share ideas, content creation, and conversation with each other. It is inspired by Git, which is a version control system for distributed tracking changes in software development. It allows collaborators to work together on idea contexts and to develop branches of multiple perspectives within those contexts. It also supports arranging and nesting different but related contexts into more complex idea structures. Video timestamp. See also this video [here](https://youtu.be/Y8gXQankAu8?t=435).
- [Set Match Games](https://www.setmatchgames.com/): a platform for collaborative for video game design. See also this video [here]( https://youtu.be/Y8gXQankAu8?t=481).
- [Hololution](https://hololution.io/): personal productivity apps that will then transform into collaboration apps. Video timestamp: https://youtu.be/Y8gXQankAu8?t=503.
- [Omni](https://github.com/OmniProject/omni): The Omni project establishes a global scholarly commons. Omni is a distributed scholarly network for direct scholarly communication, treated as main access point for all other Omni Project applications.
- [humm](https://humm.earth/): a beautiful p2p publishing platform. Control your content and its distribution, own your creativity and humanity. They're aiming to foster a new kind of economy around content creation (which Holochain would be suitable for with microtransfers). Video timestamp: https://youtu.be/Y8gXQankAu8?t=597.
- [Comet](https://github.com/MightyAlex200/Comet). Holochain powered distributed Reddit-like application, with differences. "Because it is built on Holochain, Comet has no censorship or moderation, and can run on the devices of the users without the help of servers. Comet also replaces the idea of "subreddits" with tags, and allows posts to be created and crossposted with more than 1 tag. Perhaps the most interesting feature of Comet, though, is its voting system. Firstly, votes can be fractional, they range from -1 to 1. Votes are also not counted as "objective". The scores of posts and comments are always calculated from the perspective of a particular agent (the user). This agent will have upvoted and downvoted other posts from other people. The score is counted depending on how the agent has voted on the other voters in the past. This helps fight spam, vote manipulation, and helps maintain community in an otherwise lawless space." See also this [blog post](https://holochaincitizen.com/2018/09/05/comet-the-decentralized-reddit-killer-designed-to-end-moderator-abuse-and-sybil-attacks/) and https://youtu.be/Y8gXQankAu8?t=636.
- [Junto](https://junto.foundation/). A social network designed for authenticity. See also https://holo.host/project/junto/.
- [Core.Network](https://core.network/): a social network designed to unify all social networks into a single visual dashboard.
- Haven: see https://www.youtube.com/watch?v=Y8gXQankAu8&t=809s.
- [Holohouse](https://holohouse.org/): Coliving, Coworking and Coop, sustainable and with a purpose
- [Allianceblock](https://allianceblock.io/): "The All-In-One Investment Ecosystem"
- [Orion](https://orionprotocol.io/): a liquidity aggregator protocol. "A standard for connecting to centralized and decentralized exchanges, enabling an ecosystem of dApps to solve liquidity issues and price parity. The Orion Protocol enables cross chain trading, omni-exchange accessibility, and liquidity."
- [Pacio’s](https://www.pacio.io/) [Tender](https://www.tender.buzz/). A zero-fee transaction platform for distributed apps, built on Holochain.
- [Jala](https://jala.io/): "A digital platform that makes participation in any venture verifiable, intuitive and automated without the need for intermediaries."
- [Bizgees](https://www.bizgees.org/): Transforming refugees into entrepreneurs using FinTech.
- [bHive](https://bhive.coop/): "The bHive Cooperative is a community owned person-to-person sharing economy platform being developed for Bendigo [bank] by a team of five local entrepreneurs. bHive is the future of work."
- [Joatu](https://alpha.joatu.org/): skills and goods marketplace for local communities.
- [2RowFlow](https://www.2rowflow.com/): "A Digital Commons for Treaty People in Canada"
- [Arcade City Realgame](https://arcade.city/). A decentralized ride-sharing platform. See also https://github.com/ArcadeCity/unter and https://forum.arcade.city/t/pivoting-upward/37. It's not clear whether the latest closed-source implementation is built on Holochain—so it's best to assume that it's not.
- [Infinite World Game](http://iwg.life/): "an operating system for humanity. A whole systems breakthrough in service to life.
The Infinite World Game (IWG) is an unprecedented innovation. A vision and whole-systems platform for a society and world that does things differently.  Cocreative players in the IWG organise themselves as living cells in a planetary super-organism (or ‘Universal Fractal Organism’, UFO), where ‘thriveability’ is the new name of the game for humanity and the planet. Drawing on a new world view and the principles of living systems, the IWG moves beyond our current concepts of economics and social organisation and offers a fresh way to share and regulate resources, interrelate, develop innovations, realise ourselves and co-ordinate our intelligence. As we elevate our capacity as a species, the IWG reorganises our social processes to go beyond product and profitability alone towards a world where every action is creating more life, love and thriveability for all."
- [Sacred Capital](https://www.sacred.capital/): infrastructure for building and exchanging reputational credit. See also [this blog post](https://holochaincitizen.com/2018/10/07/the-yin-and-yang-of-wealth-qa-with-the-founder-of-sacred-capital/).
- [HoloREA](https://github.com/holo-rea): happ infrastructure that uses the [Resources, events, agents (REA) accounting model](https://en.wikipedia.org/wiki/Resources,_events,_agents_(accounting_model)), with an implementation based on the [ValueFlows](https://valueflo.ws/) protocol, and is built on [Holochain](https://holochain.org/). See also [this video](https://www.youtube.com/watch?v=Xy6TB0lbj_c).
- [Cogov](http://cogov.startbutton.com/): a framework for experimentation with social system innovation. See also http://cogov.tech/.
- [Creafree](http://creafree.org/): "Creafree registers, publishes and promotes creations to better meet the needs of the 21st century."
- [Ulex](https://instituteforcompgov.org/ulex): an open source legal system. "In the case of Ulex, the “software” is not necessarily code (although you can access Tom W Bell’s Ulex Gitrepository here), rather they are rules that a legal system can operate under. Because Ulex is open source, its foundation is not tied to any one country and can be used in different jurisdictions. The goal of Ulex is to foster an open source community that creates and tries different variants of Ulex. Ulex protects human rights with an efficient and fair dispute resolution process, promoting the rule of law. It is not imposed by any one government, but instead is adopted by the mutual consent of those it governs. " See also https://physes.github.io/Ulex/ and https://ulex.app/.
- [Our World/HoloNET/HoloUnity/OASIS API](http://www.ourworldthegame.com) Our World is an exciting immersive next generation 3D XR/IR (Infinite Reality) educational game/platform/social network/ecosystem teaching people on how to look after themselves, each other and the planet using the latest cutting-edge technology.  It is the XR/IR Gamification layer of the new interplanetary operating system & the new internet (Web 3.0), which is being built by the elite technical wizards stationed around the world. It is a 5th dimensional and ascension training platform, teaching people vital life lessons as well as acting as a real-time simulation of the real world. Our World uses HoloNET (.NET Holochain client) and HoloUnity (Unity Holochain Client) and the OASIS API/Karma/Profile/Avatar System. Read more on our [GitHub Page](https://github.com/NextGenSoftwareUK/Our-World-OASIS-API-HoloNET-HoloUnity-And-.NET-HDK) or on the [Holochain Forum](https://forum.holochain.org/c/projects/our-world).

### See also
- [this video: 37 Projects Building on Holochain](https://youtu.be/Y8gXQankAu8).

